/*************************************************************************
*  Copyright (C) 2004 by Janek Kozicki                                   *
*  cosurgi@berlios.de                                                    *
*                                                                        *
*  This program is free software; it is licensed under the terms of the  *
*  GNU General Public License v2 or later. See file LICENSE for details. *
*************************************************************************/
 
#include "InteractingHollowCylinder2AABB.hpp"
#include "InteractingHollowCylinder.hpp"
#include <yade/yade-package-common/AABB.hpp>

void InteractingHollowCylinder2AABB::go(  const shared_ptr<InteractingGeometry>& cm
					, shared_ptr<BoundingVolume>& bv
					, const Se3r& se3
					, const Body*	)
{
	InteractingHollowCylinder* hc = static_cast<InteractingHollowCylinder*>(cm.get());
	AABB* aabb = static_cast<AABB*>(bv.get());
	
	aabb->center = se3.position;

// sphere
//	aabb->halfSize = Vector3r(sphere->radius,sphere->radius,sphere->radius);
// box
/*
	Matrix3r r;
	se3.orientation.toRotationMatrix(r);
	aabb->halfSize = Vector3r(0,0,0);
	for( int i=0; i<3; ++i )
		for( int j=0; j<3; ++j )
			aabb->halfSize[i] += fabs( r[i][j] * box->extents[j] );
	
	aabb->min = aabb->center-aabb->halfSize;
	aabb->max = aabb->center+aabb->halfSize;
*/

// FIXME - Axis Aligned Bounding Box for this cylinder is currently calculated wrog.
// (it is now using a formula as if the cylinder was a sphere with radius equal to outsideRadius of clinder)
// in fact it should be a different formula.
//
// above are commented examples for Sphere and for Box. based on those examples you can try to write the formula for cylinder :)
//
	aabb->halfSize = Vector3r(hc->outsideRadius,hc->outsideRadius,hc->outsideRadius);
	
	aabb->min = aabb->center - aabb->halfSize;
	aabb->max = aabb->center + aabb->halfSize;	

}
	
