/*************************************************************************
*  Copyright (C) 2004 by Janek Kozicki                                   *
*  cosurgi@berlios.de                                                    *
*                                                                        *
*  This program is free software; it is licensed under the terms of the  *
*  GNU General Public License v2 or later. See file LICENSE for details. *
*************************************************************************/

#ifndef INTERACTINGHOLLOWCYLINDER2INTERACTINGSPHERE4SPHERESCONTACTGEOMETRY_HPP
#define INTERACTINGHOLLOWCYLINDER2INTERACTINGSPHERE4SPHERESCONTACTGEOMETRY_HPP

#include <yade/yade-package-common/InteractionGeometryEngineUnit.hpp>

class InteractingHollowCylinder2InteractingSphere4SpheresContactGeometry : public InteractionGeometryEngineUnit
{
	public :
		virtual bool go(	const shared_ptr<InteractingGeometry>& cm1,
					const shared_ptr<InteractingGeometry>& cm2,
					const Se3r& se31,
					const Se3r& se32,
					const shared_ptr<Interaction>& c);
		virtual bool goReverse(	const shared_ptr<InteractingGeometry>& cm1,
					const shared_ptr<InteractingGeometry>& cm2,
					const Se3r& se31,
					const Se3r& se32,
					const shared_ptr<Interaction>& c);

	REGISTER_CLASS_NAME(InteractingHollowCylinder2InteractingSphere4SpheresContactGeometry);
	REGISTER_BASE_CLASS_NAME(InteractionGeometryEngineUnit);

	DEFINE_FUNCTOR_ORDER_2D(InteractingHollowCylinder,InteractingSphere);
};

REGISTER_SERIALIZABLE(InteractingHollowCylinder2InteractingSphere4SpheresContactGeometry,false);

#endif //  INTERACTINGHOLLOWCYLINDER2INTERACTINGSPHERE4SPHERESCONTACTGEOMETRY_HPP

